# -*- coding: utf-8 -*-
"""
/***************************************************************************
 opeNoise

 opeNoise allows to compute the noise level generated by road traffic
 at fixed receiver points and buildings.

                             -------------------
        begin                : March 2014
        copyright            : (C) 2014 by Arpa Piemonte
        email                : s.masera@arpa.piemonte.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
from ui_Informations import Ui_Info_window

class Dialog_info(QDialog,Ui_Info_window):
   
    def __init__(self, iface):
        QDialog.__init__(self, iface.mainWindow())
        self.iface = iface
        # Set up the user interface from Designer.
        self.setupUi(self)
        
        # Translations for the html parts        
        
        string = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"         "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n" "p, li { white-space: pre-wrap; }\n"         "</style></head><body style=\" font-family:\'Ubuntu\'; font-size:11pt; font-weight:400; font-style:normal;\">\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:16pt; font-weight:600;\">" + self.tr("opeNoise") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /><span style=\" font-size:12pt;\">" + self.tr("The plugin allows to compute the noise level generated by road traffic at fixed receiver points and buildings.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("The calculation is based on the French national computation method NMPB-Routes-96, as indicated in the DIRECTIVE 2002/49/EC OF THE EUROPEAN PARLIAMENT AND OF THE COUNCIL of 25 June 2002 relating to the assessment and management of environmental noise.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("Please consider the following semplifications:") + "<br />" + self.tr("- the modelization is 2D (only the distance receiver points - roads is calculated considering the receiver points at 4m on the ground);") + "<br />" + self.tr("- no reflections or diffractions are calculated;") + "<br />" + self.tr("- the terrain is flat.") + "</span></p></body></html>"
        self.textBrowser.setHtml(string)
        
        string = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n" "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n" "p, li { white-space: pre-wrap; }\n" "</style></head><body style=\" font-family:\'Ubuntu\'; font-size:11pt; font-weight:600; font-style:normal;\">\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:16pt;\">" + self.tr("Create Receiver Points") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /><span style=\" font-size:12pt; font-weight:400;\">" + self.tr("The first script generates one receiver point along all the facades of a buildings layer (a polygon layer).") + " </span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-weight:400;\">" + self.tr("The points are created at a distance of 0.1 m from the facade.") + "<br /><br /><br /></span><span style=\" font-size:12pt; font-style:italic; text-decoration: underline;\">" + self.tr("INPUT DATA: ") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-weight:400; font-style:italic;\">" + self.tr("Buildings (a polygon layer)") + "<br /><br /><br /></span><span style=\" font-size:12pt; font-style:italic; text-decoration: underline;\">" + self.tr("OUTPUT DATA: ") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-weight:400; font-style:italic;\">" + self.tr("Receiver points (a point layer)") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p></body></html>"
        self.textBrowser_8.setHtml(string)
        
        string = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n" "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n" "p, li { white-space: pre-wrap; }\n" "</style></head><body style=\" font-family:\'Ubuntu\'; font-size:11pt; font-weight:400; font-style:normal;\">\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:16pt; font-weight:600;\">" + self.tr("Calculate Noise Levels") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /><span style=\" font-size:12pt;\">" + self.tr("The second script computes the noise level at receiver points (a point layer).") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("For each road (line of a polyline layer) is calculated the emission power as established in the NMPB \'96.") + "<br />" + self.tr("Then all the distances between each receiver point and the road is calculated, and the road is divided in emission points spaced as half of the minimum distance receiver points-road.") + "<br />" + self.tr("A ray is traced between each emission point and each receiver point and then, if the length of the ray is lower then a fixed distance (choosen in the input form), the noise level will be calculated.") + "<br />" + self.tr("To compute the level, it\'s taken into account only the geometrical divergence.") + "<br />" + self.tr("If the ray cross an obstacles, it won\'t be used to the final computation.") + "<br />" + self.tr("It\'s possible to create the emission points and rays layers.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("The computation is available for 4 reference periods: Generic Level; Lday; Leve; Lnig.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("Lden, if checked, is calculated using the indication of the European Directive 2002/49/EC (it is possible to define the lasting time and the penalization factor for each reference period).") + "<br /><br />" + self.tr("The computation results are written in the attribute table of the receiver points layer.") + "<br /><br /></span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-weight:600; font-style:italic; text-decoration: underline;\">" + self.tr("INPUT DATA:") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-style:italic;\">" + self.tr("1. Receiver points layer") + "<br /></span><span style=\" font-size:12pt;\">" + self.tr("A point layer.") + "<br /><br /></span><span style=\" font-size:12pt; font-style:italic;\">" + self.tr("2. Roads layer") + "<br /></span><span style=\" font-size:12pt;\">" + self.tr("A polyline layer.") + "<br />" + self.tr("It needs a roads layer input (a polyline layer) with some attributes table fields: it\'s necessary to give some information about the characteristic of the single road to exhistimate the emission power.") + "<br />" + self.tr("It\'s possible to indicate the power (expressed in dB) or, alternatively, to specify the number of light and heavy vehicles/hour, their speeds and the characteristic of the road as traffic type, surface and slope.") + "<br />" + self.tr("The power, as defined into NMPB \'96, is: sound power level per meter of lane, corrected in the light of the road surface during the reference period.") + "<br /><br /></span><span style=\" font-size:12pt; font-style:italic;\">" + self.tr("3. Distance") + "<br /></span><span style=\" font-size:12pt;\">" + self.tr("This is the maximum distance roads-receiver points allowed.") + "<br /><br /></span><span style=\" font-size:12pt; font-style:italic;\">" + self.tr("4. Obstacles (optional)") + "<br /></span><span style=\" font-size:12pt;\">A polygon layer.<br /><br /><br /></span><span style=\" font-size:12pt; font-weight:600; font-style:italic; text-decoration: underline;\">OUTPUT DATA:</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-style:italic;\">" + self.tr("1. Emission points layer") + "<br /></span><span style=\" font-size:12pt;\">" + self.tr("A point layer.") + "<br /><br /></span><span style=\" font-size:12pt; font-style:italic;\">" + self.tr("2. Rays layer") + "<br /></span><span style=\" font-size:12pt;\">" + self.tr("A polyline layer.") + "</span></p></body></html>"
        self.textBrowser_9.setHtml(string)
        
        string = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n" "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n" "p, li { white-space: pre-wrap; }\n" "</style></head><body style=\" font-family:\'Ubuntu\'; font-size:11pt; font-weight:400; font-style:normal;\">\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:16pt; font-weight:600;\">" + self.tr("Assign Levels To Buildings") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /><span style=\" font-size:12pt;\">" + self.tr("The third script assigns the noise levels calculated for each receiver point to the corresponding building.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("The level assigned is the max level computed.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("It is possible to assign up to five levels.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("NOTE: this script works correctly only if you created the receiver points layer from a buildings layer with opeNoise and you didn\'t modify their structure.") + "<br /></span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-weight:600; font-style:italic; text-decoration: underline;\">INPUT DATA:</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-style:italic;\">" + self.tr("1. Receiver points layer") + "<br /></span><span style=\" font-size:12pt;\">" + self.tr("A point layer.") + "<br />" + self.tr("You have to select at least a level field to assign the max level to the corresponding building.") + "<br /><br /></span><span style=\" font-size:12pt; font-style:italic;\">" + self.tr("2. Buildings layer") + "<br /></span><span style=\" font-size:12pt;\">" + self.tr("A polygon layer.") + "<br /></span></p></body></html>"
        self.textBrowser_10.setHtml(string)
        
        string = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n" "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n" "p, li { white-space: pre-wrap; }\n" "</style></head><body style=\" font-family:\'Ubuntu\'; font-size:11pt; font-weight:400; font-style:normal;\">\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:16pt; font-weight:600;\">" + self.tr("Apply Noise Symbology") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /><span style=\" font-size:12pt;\">" + self.tr("The last script assigns a noise level symbology to a layer sound level field.") + "<br /></span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-weight:600; font-style:italic; text-decoration: underline;\">" + self.tr("INPUT DATA:") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-style:italic;\">" + self.tr("1. Input layer") + "<br /></span><span style=\" font-size:12pt;\">" + self.tr("You have to select a sound level field to assign the noise level symbology.") + "<br /><br /></span></p></body></html>"
        self.textBrowser_11.setHtml(string)
        
        string = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n" "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n" "p, li { white-space: pre-wrap; }\n" "</style></head><body style=\" font-family:\'Ubuntu\'; font-size:11pt; font-weight:400; font-style:normal;\">\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:16pt; font-weight:600;\">" + self.tr("NMPB-Routes-96") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /><span style=\" font-size:12pt;\">" + self.tr("The NMPB \'96 is the French national computation method for road traffic noise.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("In this plugin you can use it with the implementation of the emission power or of detailed data for each road, as the number of light and heavy vehicles, their speeds and the characteristics of the road, as traffic type, surface and slope.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("The power is the sound power level per meter of lane, corrected in the light of the road surface during the reference period.") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("The detailed data of the roads are:") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("- number of light vehicles per hour (number);") + "<br />" + self.tr("- number of heavy vehicles per hour (number);") + "<br />" + self.tr("- speed of light vehicles (number);") + "<br />" + self.tr("- speed of heavy vehicles (number);") + "<br />" + self.tr("- type of the traffic flow (string: \'continuos\', \'pulsed accelerated\', \'pulsed decelerated\', \'non-differentiated pulsed\');") + "<br />" + self.tr("- type of road surface (string: \'smooth\', \'porous\', \'stones\', \'cement\', \'corrugated\');") + "<br />" + self.tr("- slope of the road (string: \'flat\', \'down\', \'up\').") + "</span></p>\n" "<p align=\"justify\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p></body></html>"
        self.textBrowser_4.setHtml(string)
        
        string = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n" "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n" "p, li { white-space: pre-wrap; }\n" "</style></head><body style=\" font-family:\'Ubuntu\'; font-size:11pt; font-weight:400; font-style:normal;\">\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:16pt; font-weight:600;\">" + self.tr("Credits") + "</span></p>\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /><span style=\" font-size:12pt; font-style:italic; text-decoration: underline;\">opeNoise:</span></p>\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">" + self.tr("Qgis Plugin to compute noise levels") + "<br />" + self.tr("Version 0.3 - October 2014") + "<br />" + self.tr("GNU General Public License version 2 or later") + "</span></p>\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /><span style=\" font-size:12pt; font-style:italic; text-decoration: underline;\">" + self.tr("Created by:") + "<br /><br /></span><img src=\":/plugins/opeNoise/icons/icon_arpa_piemonte.png\" height=\"60\" /><br /><span style=\" font-size:12pt;\"><br />" + self.tr("Arpa Piemonte") + "<br />" + self.tr("(Environmental Protection Agency of Piedmont - Italy)") + "<br /></span><a href=\"http://www.arpa.piemonte.it\"><span style=\" text-decoration: underline; color:#0000ff;\">www.arpa.piemonte.it</span></a></p>\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt; font-style:italic; text-decoration: underline;\"><br />" + self.tr("With the support of:") + "<br /><br /></span><img src=\":/plugins/opeNoise/icons/icon_comune_torino.png\" height=\"120\" /><br /><span style=\" font-size:12pt;\"><br />" + self.tr("Città di Torino") + "<br /></span><a href=\"http://www.comune.torino.it/\"><span style=\" text-decoration: underline; color:#0000ff;\">www.comune.torino.it<br /><br /></span></a><span style=\" font-size:12pt;\"><br /></span><span style=\" font-size:12pt; font-style:italic; text-decoration: underline;\">" + self.tr("Contacs:") + "</span></p>\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">Stefano Masera<br />s.masera@arpa.piemonte.it</span></p>\n" "<p align=\"center\" style=\" margin-top:12px; margin-bottom:12px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:12pt;\">Enrico Gallo<br />enrico.gallo@comune.torino.it</span><br /><br /></p></body></html>"
        self.textBrowser_5.setHtml(string)
        
